#ifndef PW_VISUAL_MESH_RENDERER_HPP
#define PW_VISUAL_MESH_RENDERER_HPP

#include <pw/core/matrix.hpp>

#include <map>

namespace pw {

class geometry;

/**
 * @brief builds a renderer for geometry
 */
class renderer {
public:
    renderer();
    renderer(const geometry& m);

    ~renderer();

    bool create(const geometry &m);
	void release();

	void draw();
	bool ready() const;

protected:

	struct impl;
	std::unique_ptr<impl> _impl;

};

}

#endif
