#include "pw/visual/context.hpp"

#include "glad/glad.h"


namespace pw {

struct context::impl {

    void set_viewport(const rectangle& v)
    {
        glViewport(v.position.x,v.position.y,v.size.width,v.size.height);
    }

    const rectangle viewport()
    {
        float _viewport[4] = {0,0,1,1};
        glGetFloatv(GL_VIEWPORT,&_viewport[0]);
        return rectangle(_viewport);
    }

    void clear()
    {
        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    }

    uint32_t get_error() const
    {
        return glGetError();
    }

};

context::context()
    : _impl(std::make_unique<impl>())
{
}

context::~context()
{
}

void context::set_blend()
{

}

void context::set_viewport(const rectangle& v)
{
    _impl->set_viewport(v);
}

rectangle context::viewport() const
{
    return _impl->viewport();
}

void context::clear()
{
    _impl->clear();
}

u_int32_t context::get_error() const
{
    return _impl->get_error();
}

}


